-- to do
-- options:
-- -- language
-- -- abbreviations
-- -- colors?
-- -- layout (1x16 good-poor/grams-lc) (1x16 grams-lc/good-poor) (4x5) (5x4) (16x1 good-poor/grams-lc) (16x1 grams-lc/good-poor)
-- -- font size 10,12,14,16,18,20 (anything over 20 is pretty much supersized and ridiculous)

-- on startup, scan localPlayer:GetTrainedSkills() to determine the skill ID of all trained map skills
-- need to use an Update event to check each map for cooldown, disable any maps that have cooldown and show indicator


import "GaranStuff.CMapins.Class";
import "GaranStuff.CMapins.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.CMapins.Strings";
import "GaranStuff.CMapins.Table";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GaranStuff.CMapins.QSButton";

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

mainVisible=true;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
trainedSkillCount=0
trainedSkillList=localPlayer:GetTrainedSkills()
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

function UnloadPlugin()
	SaveData();

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mainWindow:RemoveShellCommands();
--	mainWindow.MouseClick=nil;
end

function SaveData()

	local settings={};

	settings[#settings+1]={"Top",mainWindow:GetTop()/Turbine.UI.Display:GetHeight()};
	settings[#settings+1]={"Left",mainWindow:GetLeft()/Turbine.UI.Display:GetWidth()};
	settings[#settings+1]={"Opacity",mainWindow.opacity};

	settings[#settings+1]={"language",language};

	PatchDataSave( Turbine.DataScope.Character, "CMapinsSettings", settings);
end

function LoadData()
	-- load saved settings
	-- try to load saved annotations
end

LoadData();

mainWindow=Turbine.UI.Window()
mainWindow.MoveX=-1;
mainWindow.MoveY=-1;
mainWindow:SetBackColor(Turbine.UI.Color(0,0,0,0));

mainWindow.cellWidth=40;
mainWindow.cellHeight=20;
-- load the settings and set the window position if possible, otherwise default to center
local initHeight=mainWindow.cellHeight*4+19;
local initWidth=mainWindow.cellWidth*5;
local initLeft=(Turbine.UI.Display:GetWidth()-initWidth)/2/Turbine.UI.Display:GetWidth();
local initTop=(Turbine.UI.Display:GetHeight()-initHeight)/2/Turbine.UI.Display:GetHeight();
mainWindow.opacity=1;

tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "CMapinsSettings");
if (tmpSettings~=nil) then
	if tostring(type(tmpSettings))=="table" then
--		if tmpSettings["Top"]~=nil then initTop=euroNormalize(tmpSettings["Top"]) end
--		if tmpSettings["Left"]~=nil then initLeft=euroNormalize(tmpSettings["Left"]) end
--		if tmpSettings["Opacity"]~=nil then mainWindow.opacity=euroNormalize(tmpSettings["Opacity"]) end
--		if tmpSettings["language"]~=nil then language=tonumber(tmpSettings["language"]) end
--		if tmpSettings["DataVersion"]~=nil then priorDataVersion=tmpSettings["DataVersion"] end

		for index=1,#tmpSettings do
			if tostring(type(tmpSettings[index]))=="table" then
				if (tmpSettings[index][1]=="Top") then
					initTop=euroNormalize(tmpSettings[index][2]);
				elseif (tmpSettings[index][1]=="Left") then
					initLeft=euroNormalize(tmpSettings[index][2]);
				elseif (tmpSettings[index][1]=="Opacity") then
					mainWindow.opacity=euroNormalize(tmpSettings[index][2]);
				elseif (tmpSettings[index][1]=="language") then
					if tonumber(tmpSettings[index][2])~=nil then
						language=tonumber(tmpSettings[index][2]);
					end
				elseif (tmpSettings[index][1]=="DataVersion") then
					priorDataVersion=tmpSettings[index][2];
				end
			end
		end

	end

	-- force initTop and initLeft to values (0-1) -- don't allow positioning off screen
	if initTop>1 then initTop=1 end
	if initLeft>1 then initLeft=1 end
	if initTop*Turbine.UI.Display:GetHeight()<-16 then initTop=-16/Turbine.UI.Display:GetHeight() end
	if initLeft<0 then initLeft=0 end
end

mainWindow:SetPosition( initLeft*Turbine.UI.Display:GetWidth(), initTop*Turbine.UI.Display:GetHeight());
mainWindow:SetHeight(initHeight);
mainWindow:SetWidth(initWidth);
mainWindow:SetVisible(false);

mainWindow:SetOpacity(0);

mainWindow:SetText(Resource[language][2]);

mapin={{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{}}
mapin[1].SkillID=0x70028BB7;
mapin[1].SkillName="Carte grossi\195\168re pour aller \195\160 Lugazag"  --mapin[11].SkillName="Crude Map to Lugazag"
mapin[2].SkillID=0x70028BBE;
mapin[2].SkillName="Carte grossi\195\168re pour aller \195\160 Tirith Rhaw"  --mapin[14].SkillName="Crude Map to Tirith Rhaw"
mapin[3].SkillID=0x70028BB6;
mapin[3].SkillName="Carte grossi\195\168re pour aller \195\160 Tol Ascarnen"  --mapin[13].SkillName="Crude Map to Tol Ascarnen"
mapin[4].SkillID=0x70028BB3;
mapin[4].SkillName="Carte grossi\195\168re pour aller au Gouffre d'Isen"  --mapin[12].SkillName="Crude Map to Isendeep"
mapin[5].SkillID=0x70028BBF;
mapin[5].SkillName="Carte grossi\195\168re pour aller au Bois Funeste"  --mapin[15].SkillName="Crude Map to Grimwood"
mapin[6].SkillID=0x70028BB2;
mapin[6].SkillName="Pi\195\168tre carte pour aller \195\160 Lugazag"  --mapin[6].SkillName="Poor Map to Lugazag"
mapin[7].SkillID=0x70028BB4;
mapin[7].SkillName="Pi\195\168tre carte pour aller \195\160 Tirith Rhaw"  --mapin[9].SkillName="Poor Map to Tirith Rhaw"
mapin[8].SkillID=0x70028BB1;
mapin[8].SkillName="Pi\195\168tre carte pour aller \195\160 Tol Ascarnen"   --mapin[8].SkillName="Poor Map to Tol Ascarnen"
mapin[9].SkillID=0x70028BAF;
mapin[9].SkillName="Pi\195\168tre carte pour aller au Gouffre d'Isen"  --mapin[7].SkillName="Poor Map to Isendeep"
mapin[10].SkillID=0x70028BB9;
mapin[10].SkillName="Pi\195\168tre carte pour aller au Bois Funeste"   --mapin[10].SkillName="Poor Map to Grimwood"
mapin[11].SkillID=0x70028BB5;
mapin[11].SkillName="Bonne carte pour aller \195\160 Lugazag"  --mapin[1].SkillName="Good Map to Lugazag"
mapin[12].SkillID=0x70028BB0;
mapin[12].SkillName="Bonne carte pour aller \195\160 Tirith Rhaw"  --mapin[4].SkillName="Good Map to Tirith Rhaw"
mapin[13].SkillID=0x70028BC2;
mapin[13].SkillName="Bonne carte pour aller \195\160 Tol Ascarnen"  --mapin[3].SkillName="Good Map to Tol Ascarnen"
mapin[14].SkillID=0x70028BC0;
mapin[14].SkillName="Bonne carte pour aller au Gouffre d'Isen"  --mapin[2].SkillName="Good Map to Isendeep"
mapin[15].SkillID=0x70028BBD;
mapin[15].SkillName="Bonne carte pour aller au Bois Funeste"  --mapin[5].SkillName="Good Map to Grimwood"
mapin[16].SkillID=0x70028BC1;
mapin[16].SkillName="Carte pour aller au Pied de Gram"  --mapin[16].SkillName="Map to Gramsfoot"


mainWindow.MovePanel=Turbine.UI.Control();
mainWindow.MovePanel:SetParent(mainWindow);
mainWindow.MovePanel:SetSize(mainWindow:GetWidth(),19);
mainWindow.MovePanel.Icon1=Turbine.UI.Control();
mainWindow.MovePanel.Icon1:SetParent(mainWindow.MovePanel);
mainWindow.MovePanel.Icon1:SetSize(19,19);
mainWindow.MovePanel.Icon1:SetBackground("GaranStuff/CMapins/Resources/move.tga");
mainWindow.MovePanel.Icon1:SetMouseVisible(false);
mainWindow.MovePanel.Icon2=Turbine.UI.Label();
mainWindow.MovePanel.Icon2:SetParent(mainWindow.MovePanel);
mainWindow.MovePanel.Icon2:SetPosition(19,3);
mainWindow.MovePanel.Icon2:SetSize(mainWindow:GetWidth()-19,12);
mainWindow.MovePanel.Icon2:SetBackground("GaranStuff/CMapins/Resources/move2.tga");
mainWindow.MovePanel.Icon2:SetFont(Turbine.UI.Lotro.Font.Verdana12)
mainWindow.MovePanel.Icon2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mainWindow.MovePanel.Icon2:SetText(Resource[language][2]);
mainWindow.MovePanel.Icon2:SetMouseVisible(false);

mainWindow.MovePanel:SetVisible(false);

mainWindow.MovePanel.MouseDown=function(sender,args)
	mainWindow.MoveX=args.X;
	mainWindow.MoveY=args.Y;
	mainWindow.MovingIcon:SetLeft(args.X-12);
	mainWindow.MovingIcon:SetTop(args.Y-12);
	mainWindow.MovingIcon:SetSize(32,32);
	mainWindow.MovingIcon:SetBackground(0x410000dd)
end

mainWindow.MovePanel.MouseMove=function(sender,args)
	if mainWindow.Moving then
		mainWindow:SetOpacity(mainWindow.opacity);
	end
	if (mainWindow.MoveY>-1 ) then
		if (args.X~=mainWindow.MoveX or args.Y~= mainWindow.MoveY) then
			mainWindow.Moving=true;
			local newLeft=mainWindow:GetLeft()-(mainWindow.MoveX-args.X)
			local newTop=mainWindow:GetTop()-(mainWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-mainWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-mainWindow:GetWidth() end;
			if newTop<-16 then newTop=-16 end;
			if newTop>(Turbine.UI.Display.GetHeight()-mainWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-mainWindow:GetHeight() end;
			mainWindow:SetPosition(newLeft,newTop);
		end
	end
end

mainWindow.MovePanel.MouseUp=function(sender,args)
	mainWindow.MovingIcon:SetVisible(false);
	mainWindow.MoveX=-1;
	mainWindow.MoveY=-1;
	mainWindow.Moving=false;
end
mapGrid=Turbine.UI.Control();
mapGrid:SetParent(mainWindow);
mapGrid:SetSize(mainWindow:GetWidth(),mainWindow:GetHeight()-mainWindow.MovePanel:GetHeight())
mapGrid:SetPosition(0,mainWindow.MovePanel:GetHeight())
mapGrid:SetBackColor(Turbine.UI.Color(.7,.2,.2,.2));

mainWindow.QS={};
mainWindow.Timer={};
for row=1,3 do
	local rowColor;
	if row==1 then
		rowColor=Turbine.UI.Color(0,1,0);
	elseif row==2 then
		rowColor=Turbine.UI.Color(.9,.7,0);
	else
		rowColor=Turbine.UI.Color(0,2,9);
	end
	for col=1,5 do
		local qsindex=(row-1)*5+col
		mainWindow.QS[qsindex]=QSButton(Turbine.UI.Lotro.ShortcutType.Skill,string.format("0x%x",mapin[(row-1)*5+col].SkillID));
		mainWindow.QS[qsindex]:SetParent(mapGrid);
		mainWindow.QS[qsindex]:SetBackColor(Turbine.UI.Color(0,0,0));
		mainWindow.QS[qsindex]:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		mainWindow.QS[qsindex]:SetSize(mainWindow.cellWidth,mainWindow.cellHeight);
		mainWindow.QS[qsindex]:SetForeColor(rowColor);
		mainWindow.QS[qsindex]:SetPosition((col-1)*mainWindow.cellWidth,(row)*mainWindow.cellHeight);
		mainWindow.QS[qsindex]:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
		mainWindow.QS[qsindex]:SetText(Resource[language][col+3]);
		mainWindow.QS[qsindex]:SetVisible(false);
		mainWindow.Timer[qsindex]=Turbine.UI.Label()
		mainWindow.Timer[qsindex]:SetParent(mapGrid)
		mainWindow.Timer[qsindex]:SetFont(Turbine.UI.Lotro.Font.Verdana12)
		mainWindow.Timer[qsindex]:SetSize(mainWindow.cellWidth,mainWindow.cellHeight);
		mainWindow.Timer[qsindex]:SetForeColor(Turbine.UI.Color.Gray);
		mainWindow.Timer[qsindex]:SetPosition((col-1)*mainWindow.cellWidth,(row)*mainWindow.cellHeight);
		mainWindow.Timer[qsindex]:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
		mainWindow.Timer[qsindex]:SetMouseVisible(false);
		mainWindow.Timer[qsindex]:SetVisible(false);
	end
end
mainWindow.QS[16]=QSButton(Turbine.UI.Lotro.ShortcutType.Skill,string.format("0x%x",mapin[16].SkillID));
mainWindow.QS[16]:SetParent(mapGrid);
mainWindow.QS[16]:SetBackColor(Turbine.UI.Color(0,0,0));
mainWindow.QS[16]:SetFont(Turbine.UI.Lotro.Font.Verdana12);
mainWindow.QS[16]:SetSize(mainWindow:GetWidth(),mainWindow.cellHeight);
mainWindow.QS[16]:SetPosition(0,0);
mainWindow.QS[16]:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
mainWindow.QS[16]:SetText(Resource[language][9]);
mainWindow.QS[16]:SetVisible(false);
mainWindow.Timer[16]=Turbine.UI.Label()
mainWindow.Timer[16]:SetParent(mapGrid)
mainWindow.Timer[16]:SetFont(Turbine.UI.Lotro.Font.Verdana12)
mainWindow.Timer[16]:SetSize(mainWindow.cellWidth,mainWindow.cellHeight);
mainWindow.Timer[16]:SetForeColor(Turbine.UI.Color.Gray);
mainWindow.Timer[16]:SetPosition(mainWindow:GetWidth()/2-mainWindow.cellWidth/2,0);
mainWindow.Timer[16]:SetMouseVisible(false);
mainWindow.Timer[16]:SetVisible(false);
mainWindow.Timer[16]:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);

mainWindow.MovingIcon=Turbine.UI.Control();
mainWindow.MovingIcon:SetParent(mainWindow);
mainWindow.MovingIcon:SetSize(32,32);
mainWindow.MovingIcon:SetStretchMode(1); -- allows it to display past the parent's bounds
mainWindow.MovingIcon:SetBackground(0x410081c0)
mainWindow.MovingIcon:SetPosition(mainWindow:GetWidth()/2-15,mainWindow:GetHeight()-21);
mainWindow.MovingIcon:SetMouseVisible(false);
mainWindow.MovingIcon:SetVisible(false);

mainWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
--		mainWindow:SetVisible(false);
	elseif ( args.Action == 268435579 ) then -- reposition UI
		mainWindow.MovePanel:SetVisible(not mainWindow.MovePanel:IsVisible());
		if mainWindow.MovePanel:IsVisible() then
			mainWindow:SetOpacity(1);
		else
			mainWindow:SetOpacity(0);
		end
	elseif ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mainWindow:SetVisible(mainVisible);
		else
			mainVisible=mainWindow:IsVisible();
			mainWindow:SetVisible(false);
		end
	end
end

mainWindow.MouseEnter=function(sender,args)
	mainWindow:SetOpacity(mainWindow.opacity);
end
mainWindow.MouseLeave=function(sender,args)
	if not mainWindow.MovePanel:IsVisible() then
		mainWindow:SetOpacity(0);
	end
end

mainWindow.MouseClick=function(sender,args)
	if not mainWindow.Moving and args.Button==2 then
		-- user right clicked on main window
	end
end

mainWindow:SetWantsKeyEvents(true);
mainWindow:SetWantsUpdates(true)

mainWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mainWindow.shellCmd)
end

mainWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand("CMapins",mainWindow.shellCmd);

mainWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == "CMapins") then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			mainWindow:SetVisible(true);
			mainWindow:SetOpacity(1);
		elseif (command=="hide") then
			mainWindow:SetVisible(false);
			mainWindow:SetOpacity(0);
		elseif (command=="toggle") then
			mainWindow:SetVisible(not mainWindow:IsVisible());
			if mainWindow:IsVisible() then
				mainWindow:SetOpacity(1);
			else
				mainWindow:SetOpacity(0);
			end
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /CMapins show");
			Turbine.Shell.WriteLine("       Displays CMapins.");
			Turbine.Shell.WriteLine("  /CMapins hide");
			Turbine.Shell.WriteLine("       Hides CMapins.");
			Turbine.Shell.WriteLine("  /CMapins toggle");
			Turbine.Shell.WriteLine("       Toggles CMapins (shows it if it was hidden, hides it if it was showing).");
		end
	end
end
mainWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /CMapins show\n       Displays CMapins.\n  /CMapins hide\n       Hides CMapins.\n  /CMapins toggle\n       Toggles CMapins (shows it if it was hidden, hides it if it was showing).");
end

mainWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("CMapins - usage: /CMapins show | hide | toggle");
end
mainWindow.SetLanguage=function()
	if mapStrings[language]==nil or type(mapStrings[language])~="table" then
		mapStrings[language]={};
	end
	mainWindow:SetText(Resource[language][2]);
end

refreshMapSkills=function()
	for index=1,trainedSkillList:GetCount() do
		local skill=trainedSkillList:GetItem(index)
		local skillInfo=skill:GetSkillInfo()
		for k,v in ipairs(mapin) do
			if v.SkillName==skillInfo:GetName() then
				mapin[k].SkillIndex=index
				-- make this map visible
				mainWindow.QS[k]:SetVisible(true)
			end
		end
	end
end

function mainWindow:Update( sender, args )
	if (Plugins["CMapins"] ~= nil) then
		if not mainWindow.Loaded then
			mainWindow.Loaded=true
			if not mainWindow.Refreshing then
				Turbine.Shell.WriteLine("CMapins "..Plugins["CMapins"]:GetVersion()..Resource[language][3]);
			end
			Plugins["CMapins"].Unload = function(self,sender,args)
				UnloadPlugin();
			end
		else
			for index,qs in ipairs(mainWindow.QS) do
				local timer=-1
				if mapin[index].SkillIndex~=nil then
					local skill=trainedSkillList:GetItem(mapin[index].SkillIndex)
					if skill~=nil then
						skillTime=skill:GetResetTime()
						if skillTime~=nil and skillTime~=-1 then
							timer=math.floor(skillTime-Turbine.Engine:GetGameTime())
							local resetMin=math.floor(timer/60)
							timer=timer-resetMin*60
							if timer<10 then
								mainWindow.Timer[index]:SetText(tostring(resetMin)..":0"..tostring(timer))
							else
								mainWindow.Timer[index]:SetText(tostring(resetMin)..":"..tostring(timer))
							end
							if not mainWindow.Timer[index]:IsVisible() then
								mainWindow.Timer[index]:SetVisible(true)
							end
						end
					end
				end
				if timer==-1 and mainWindow.Timer[index]:IsVisible() then
					mainWindow.Timer[index]:SetVisible(false)
				end
			end

			if trainedSkillCount~=localPlayer:GetTrainedSkills():GetCount() then
				trainedSkillCount=localPlayer:GetTrainedSkills():GetCount()
				refreshMapSkills()
			end
		end
	end
end

LoadData();


if priorDataVersion~=Plugins["CMapins"]:GetVersion() then
	-- perform version change auto update stuff
end

mainWindow:SetVisible(true);

